<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_67) on Wed Sep 10 14:57:28 CEST 2014 -->
<title>WebSocketImpl</title>
<meta name="date" content="2014-09-10">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="WebSocketImpl";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketImpl.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../org/java_websocket/WebSocketFactory.html" title="interface in org.java_websocket"><span class="strong">Prev Class</span></a></li>
<li><a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?org/java_websocket/WebSocketImpl.html" target="_top">Frames</a></li>
<li><a href="WebSocketImpl.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.java_websocket</div>
<h2 title="Class WebSocketImpl" class="title">Class WebSocketImpl</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>org.java_websocket.WebSocketImpl</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="strong">WebSocketImpl</span>
extends java.lang.Object
implements <a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></pre>
<div class="block">Represents one end (client or server) of a single WebSocketImpl connection.
 Takes care of the "handshake" phase, then allows for easy sending of
 text frames, and receiving frames through an event-based model.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="nested_classes_inherited_from_class_org.java_websocket.WebSocket">
<!--   -->
</a>
<h3>Nested classes/interfaces inherited from interface&nbsp;org.java_websocket.<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></h3>
<code><a href="../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a>, <a href="../../org/java_websocket/WebSocket.Role.html" title="enum in org.java_websocket">WebSocket.Role</a></code></li>
</ul>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.nio.channels.ByteChannel</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#channel">channel</a></strong></code>
<div class="block">the possibly wrapped channel object whose selection is controlled by <a href="../../org/java_websocket/WebSocketImpl.html#key"><code>key</code></a></div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.lang.Integer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#closecode">closecode</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.lang.Boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#closedremotely">closedremotely</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#closemessage">closemessage</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../org/java_websocket/framing/Framedata.Opcode.html" title="enum in org.java_websocket.framing">Framedata.Opcode</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#current_continuous_frame_opcode">current_continuous_frame_opcode</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#DEBUG">DEBUG</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#defaultdraftlist">defaultdraftlist</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#draft">draft</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#flushandclosestate">flushandclosestate</a></strong></code>
<div class="block">When true no further frames may be submitted to be sent</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#handshakerequest">handshakerequest</a></strong></code>
<div class="block">stores the handshake sent by this websocket ( Role.CLIENT only )</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.util.concurrent.BlockingQueue&lt;java.nio.ByteBuffer&gt;</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#inQueue">inQueue</a></strong></code>
<div class="block">Queue of buffers that need to be processed</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.nio.channels.SelectionKey</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#key">key</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#knownDrafts">knownDrafts</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.util.concurrent.BlockingQueue&lt;java.nio.ByteBuffer&gt;</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#outQueue">outQueue</a></strong></code>
<div class="block">Queue of buffers that need to be sent to the client.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#RCVBUF">RCVBUF</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#readystate">readystate</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#resourceDescriptor">resourceDescriptor</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../org/java_websocket/WebSocket.Role.html" title="enum in org.java_websocket">WebSocket.Role</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#role">role</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#tmpHandshakeBytes">tmpHandshakeBytes</a></strong></code>
<div class="block">the bytes of an incomplete received handshake</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../org/java_websocket/server/WebSocketServer.WebSocketWorker.html" title="class in org.java_websocket.server">WebSocketServer.WebSocketWorker</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#workerThread">workerThread</a></strong></code>
<div class="block">Helper variable meant to store the thread which ( exclusively ) triggers this objects decode method.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#wsl">wsl</a></strong></code>
<div class="block">The listener to notify of WebSocket events.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_org.java_websocket.WebSocket">
<!--   -->
</a>
<h3>Fields inherited from interface&nbsp;org.java_websocket.<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></h3>
<code><a href="../../org/java_websocket/WebSocket.html#DEFAULT_PORT">DEFAULT_PORT</a>, <a href="../../org/java_websocket/WebSocket.html#DEFAULT_WSS_PORT">DEFAULT_WSS_PORT</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#WebSocketImpl(org.java_websocket.WebSocketListener,%20org.java_websocket.drafts.Draft)">WebSocketImpl</a></strong>(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
             <a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft)</code>
<div class="block">crates a websocket with client role</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#WebSocketImpl(org.java_websocket.WebSocketListener,%20org.java_websocket.drafts.Draft,%20java.net.Socket)">WebSocketImpl</a></strong>(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
             <a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft,
             java.net.Socket&nbsp;socket)</code>
<div class="block"><strong>Deprecated.</strong>&nbsp;</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#WebSocketImpl(org.java_websocket.WebSocketListener,%20java.util.List)">WebSocketImpl</a></strong>(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
             java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts)</code>
<div class="block">crates a websocket with server role</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#WebSocketImpl(org.java_websocket.WebSocketListener,%20java.util.List,%20java.net.Socket)">WebSocketImpl</a></strong>(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
             java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts,
             java.net.Socket&nbsp;socket)</code>
<div class="block"><strong>Deprecated.</strong>&nbsp;</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#close()">close</a></strong>()</code>
<div class="block">Convenience function which behaves like close(CloseFrame.NORMAL)</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#close(int)">close</a></strong>(int&nbsp;code)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#close(int,%20java.lang.String)">close</a></strong>(int&nbsp;code,
     java.lang.String&nbsp;message)</code>
<div class="block">sends the closing handshake.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#close(int,%20java.lang.String,%20boolean)">close</a></strong>(int&nbsp;code,
     java.lang.String&nbsp;message,
     boolean&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#close(org.java_websocket.exceptions.InvalidDataException)">close</a></strong>(<a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a>&nbsp;e)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#closeConnection()">closeConnection</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#closeConnection(int,%20boolean)">closeConnection</a></strong>(int&nbsp;code,
               boolean&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#closeConnection(int,%20java.lang.String)">closeConnection</a></strong>(int&nbsp;code,
               java.lang.String&nbsp;message)</code>
<div class="block">This will close the connection immediately without a proper close handshake.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#closeConnection(int,%20java.lang.String,%20boolean)">closeConnection</a></strong>(int&nbsp;code,
               java.lang.String&nbsp;message,
               boolean&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#decode(java.nio.ByteBuffer)">decode</a></strong>(java.nio.ByteBuffer&nbsp;socketBuffer)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#decodeFrames(java.nio.ByteBuffer)">decodeFrames</a></strong>(java.nio.ByteBuffer&nbsp;socketBuffer)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#decodeHandshake(java.nio.ByteBuffer)">decodeHandshake</a></strong>(java.nio.ByteBuffer&nbsp;socketBufferNew)</code>
<div class="block">Returns whether the handshake phase has is completed.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#eot()">eot</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#flushAndClose(int,%20java.lang.String,%20boolean)">flushAndClose</a></strong>(int&nbsp;code,
             java.lang.String&nbsp;message,
             boolean&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#getDraft()">getDraft</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#getLocalSocketAddress()">getLocalSocketAddress</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#getReadyState()">getReadyState</a></strong>()</code>
<div class="block">Retrieve the WebSocket 'readyState'.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#getRemoteSocketAddress()">getRemoteSocketAddress</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#getResourceDescriptor()">getResourceDescriptor</a></strong>()</code>
<div class="block">Returns the HTTP Request-URI as defined by http://tools.ietf.org/html/rfc2616#section-5.1.2<br>
 If the opening handshake has not yet happened it will return null.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#hasBufferedData()">hasBufferedData</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#hashCode()">hashCode</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#isClosed()">isClosed</a></strong>()</code>
<div class="block">Returns whether the close handshake has been completed and the socket is closed.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#isClosing()">isClosing</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#isConnecting()">isConnecting</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../org/java_websocket/drafts/Draft.HandshakeState.html" title="enum in org.java_websocket.drafts">Draft.HandshakeState</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#isFlashEdgeCase(java.nio.ByteBuffer)">isFlashEdgeCase</a></strong>(java.nio.ByteBuffer&nbsp;request)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#isFlushAndClose()">isFlushAndClose</a></strong>()</code>
<div class="block">Returns true when no further frames may be submitted<br>
 This happens before the socket connection is closed.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#isOpen()">isOpen</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#open(org.java_websocket.handshake.Handshakedata)">open</a></strong>(<a href="../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;d)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#send(byte[])">send</a></strong>(byte[]&nbsp;bytes)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#send(java.nio.ByteBuffer)">send</a></strong>(java.nio.ByteBuffer&nbsp;bytes)</code>
<div class="block">Send Binary data (plain bytes) to the other end.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#send(java.util.Collection)">send</a></strong>(java.util.Collection&lt;<a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&gt;&nbsp;frames)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#send(java.lang.String)">send</a></strong>(java.lang.String&nbsp;text)</code>
<div class="block">Send Text data to the other end.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode,%20java.nio.ByteBuffer,%20boolean)">sendFragmentedFrame</a></strong>(<a href="../../org/java_websocket/framing/Framedata.Opcode.html" title="enum in org.java_websocket.framing">Framedata.Opcode</a>&nbsp;op,
                   java.nio.ByteBuffer&nbsp;buffer,
                   boolean&nbsp;fin)</code>
<div class="block">Allows to send continuous/fragmented frames conveniently.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#sendFrame(org.java_websocket.framing.Framedata)">sendFrame</a></strong>(<a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;framedata)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#startHandshake(org.java_websocket.handshake.ClientHandshakeBuilder)">startHandshake</a></strong>(<a href="../../org/java_websocket/handshake/ClientHandshakeBuilder.html" title="interface in org.java_websocket.handshake">ClientHandshakeBuilder</a>&nbsp;handshakedata)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#toString()">toString</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#write(java.nio.ByteBuffer)">write</a></strong>(java.nio.ByteBuffer&nbsp;buf)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketImpl.html#write(java.util.List)">write</a></strong>(java.util.List&lt;java.nio.ByteBuffer&gt;&nbsp;bufs)</code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="RCVBUF">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>RCVBUF</h4>
<pre>public static&nbsp;int RCVBUF</pre>
</li>
</ul>
<a name="DEBUG">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DEBUG</h4>
<pre>public static&nbsp;boolean DEBUG</pre>
</li>
</ul>
<a name="defaultdraftlist">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>defaultdraftlist</h4>
<pre>public static final&nbsp;java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt; defaultdraftlist</pre>
</li>
</ul>
<a name="key">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>key</h4>
<pre>public&nbsp;java.nio.channels.SelectionKey key</pre>
</li>
</ul>
<a name="channel">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>channel</h4>
<pre>public&nbsp;java.nio.channels.ByteChannel channel</pre>
<div class="block">the possibly wrapped channel object whose selection is controlled by <a href="../../org/java_websocket/WebSocketImpl.html#key"><code>key</code></a></div>
</li>
</ul>
<a name="outQueue">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>outQueue</h4>
<pre>public final&nbsp;java.util.concurrent.BlockingQueue&lt;java.nio.ByteBuffer&gt; outQueue</pre>
<div class="block">Queue of buffers that need to be sent to the client.</div>
</li>
</ul>
<a name="inQueue">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>inQueue</h4>
<pre>public final&nbsp;java.util.concurrent.BlockingQueue&lt;java.nio.ByteBuffer&gt; inQueue</pre>
<div class="block">Queue of buffers that need to be processed</div>
</li>
</ul>
<a name="workerThread">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>workerThread</h4>
<pre>public volatile&nbsp;<a href="../../org/java_websocket/server/WebSocketServer.WebSocketWorker.html" title="class in org.java_websocket.server">WebSocketServer.WebSocketWorker</a> workerThread</pre>
<div class="block">Helper variable meant to store the thread which ( exclusively ) triggers this objects decode method.</div>
</li>
</ul>
<a name="flushandclosestate">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>flushandclosestate</h4>
<pre>private volatile&nbsp;boolean flushandclosestate</pre>
<div class="block">When true no further frames may be submitted to be sent</div>
</li>
</ul>
<a name="readystate">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>readystate</h4>
<pre>private&nbsp;<a href="../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a> readystate</pre>
</li>
</ul>
<a name="wsl">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>wsl</h4>
<pre>private final&nbsp;<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a> wsl</pre>
<div class="block">The listener to notify of WebSocket events.</div>
</li>
</ul>
<a name="knownDrafts">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>knownDrafts</h4>
<pre>private&nbsp;java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt; knownDrafts</pre>
</li>
</ul>
<a name="draft">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>draft</h4>
<pre>private&nbsp;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a> draft</pre>
</li>
</ul>
<a name="role">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>role</h4>
<pre>private&nbsp;<a href="../../org/java_websocket/WebSocket.Role.html" title="enum in org.java_websocket">WebSocket.Role</a> role</pre>
</li>
</ul>
<a name="current_continuous_frame_opcode">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>current_continuous_frame_opcode</h4>
<pre>private&nbsp;<a href="../../org/java_websocket/framing/Framedata.Opcode.html" title="enum in org.java_websocket.framing">Framedata.Opcode</a> current_continuous_frame_opcode</pre>
</li>
</ul>
<a name="tmpHandshakeBytes">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>tmpHandshakeBytes</h4>
<pre>private&nbsp;java.nio.ByteBuffer tmpHandshakeBytes</pre>
<div class="block">the bytes of an incomplete received handshake</div>
</li>
</ul>
<a name="handshakerequest">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>handshakerequest</h4>
<pre>private&nbsp;<a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a> handshakerequest</pre>
<div class="block">stores the handshake sent by this websocket ( Role.CLIENT only )</div>
</li>
</ul>
<a name="closemessage">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closemessage</h4>
<pre>private&nbsp;java.lang.String closemessage</pre>
</li>
</ul>
<a name="closecode">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closecode</h4>
<pre>private&nbsp;java.lang.Integer closecode</pre>
</li>
</ul>
<a name="closedremotely">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closedremotely</h4>
<pre>private&nbsp;java.lang.Boolean closedremotely</pre>
</li>
</ul>
<a name="resourceDescriptor">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>resourceDescriptor</h4>
<pre>private&nbsp;java.lang.String resourceDescriptor</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="WebSocketImpl(org.java_websocket.WebSocketListener, java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketImpl</h4>
<pre>public&nbsp;WebSocketImpl(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
             java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts)</pre>
<div class="block">crates a websocket with server role</div>
</li>
</ul>
<a name="WebSocketImpl(org.java_websocket.WebSocketListener, org.java_websocket.drafts.Draft)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketImpl</h4>
<pre>public&nbsp;WebSocketImpl(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
             <a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft)</pre>
<div class="block">crates a websocket with client role</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>socket</code> - may be unbound</dd></dl>
</li>
</ul>
<a name="WebSocketImpl(org.java_websocket.WebSocketListener, org.java_websocket.drafts.Draft, java.net.Socket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketImpl</h4>
<pre>@Deprecated
public&nbsp;WebSocketImpl(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
                        <a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft,
                        java.net.Socket&nbsp;socket)</pre>
<div class="block"><span class="strong">Deprecated.</span>&nbsp;</div>
</li>
</ul>
<a name="WebSocketImpl(org.java_websocket.WebSocketListener, java.util.List, java.net.Socket)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>WebSocketImpl</h4>
<pre>@Deprecated
public&nbsp;WebSocketImpl(<a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a>&nbsp;listener,
                        java.util.List&lt;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&gt;&nbsp;drafts,
                        java.net.Socket&nbsp;socket)</pre>
<div class="block"><span class="strong">Deprecated.</span>&nbsp;</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="decode(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre>public&nbsp;void&nbsp;decode(java.nio.ByteBuffer&nbsp;socketBuffer)</pre>
</li>
</ul>
<a name="decodeHandshake(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeHandshake</h4>
<pre>private&nbsp;boolean&nbsp;decodeHandshake(java.nio.ByteBuffer&nbsp;socketBufferNew)</pre>
<div class="block">Returns whether the handshake phase has is completed.
 In case of a broken handshake this will be never the case.</div>
</li>
</ul>
<a name="decodeFrames(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeFrames</h4>
<pre>private&nbsp;void&nbsp;decodeFrames(java.nio.ByteBuffer&nbsp;socketBuffer)</pre>
</li>
</ul>
<a name="close(int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>private&nbsp;void&nbsp;close(int&nbsp;code,
         java.lang.String&nbsp;message,
         boolean&nbsp;remote)</pre>
</li>
</ul>
<a name="close(int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close(int&nbsp;code,
         java.lang.String&nbsp;message)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#close(int,%20java.lang.String)">WebSocket</a></code></strong></div>
<div class="block">sends the closing handshake.
 may be send in response to an other handshake.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#close(int,%20java.lang.String)">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="closeConnection(int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeConnection</h4>
<pre>protected&nbsp;void&nbsp;closeConnection(int&nbsp;code,
                   java.lang.String&nbsp;message,
                   boolean&nbsp;remote)</pre>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>remote</code> - Indicates who "generated" <code>code</code>.<br>
            <code>true</code> means that this endpoint received the <code>code</code> from the other endpoint.<br>
            false means this endpoint decided to send the given code,<br>
            <code>remote</code> may also be true if this endpoint started the closing handshake since the other endpoint may not simply echo the <code>code</code> but close the connection the same time this endpoint does do but with an other <code>code</code>. <br></dd></dl>
</li>
</ul>
<a name="closeConnection(int, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeConnection</h4>
<pre>protected&nbsp;void&nbsp;closeConnection(int&nbsp;code,
                   boolean&nbsp;remote)</pre>
</li>
</ul>
<a name="closeConnection()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeConnection</h4>
<pre>public&nbsp;void&nbsp;closeConnection()</pre>
</li>
</ul>
<a name="closeConnection(int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeConnection</h4>
<pre>public&nbsp;void&nbsp;closeConnection(int&nbsp;code,
                   java.lang.String&nbsp;message)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#closeConnection(int,%20java.lang.String)">WebSocket</a></code></strong></div>
<div class="block">This will close the connection immediately without a proper close handshake.
 The code and the message therefore won't be transfered over the wire also they will be forwarded to onClose/onWebsocketClose.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#closeConnection(int,%20java.lang.String)">closeConnection</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="flushAndClose(int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>flushAndClose</h4>
<pre>protected&nbsp;void&nbsp;flushAndClose(int&nbsp;code,
                 java.lang.String&nbsp;message,
                 boolean&nbsp;remote)</pre>
</li>
</ul>
<a name="eot()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>eot</h4>
<pre>public&nbsp;void&nbsp;eot()</pre>
</li>
</ul>
<a name="close(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close(int&nbsp;code)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#close(int)">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="close(org.java_websocket.exceptions.InvalidDataException)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close(<a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a>&nbsp;e)</pre>
</li>
</ul>
<a name="send(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>send</h4>
<pre>public&nbsp;void&nbsp;send(java.lang.String&nbsp;text)
          throws <a href="../../org/java_websocket/exceptions/WebsocketNotConnectedException.html" title="class in org.java_websocket.exceptions">WebsocketNotConnectedException</a></pre>
<div class="block">Send Text data to the other end.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#send(java.lang.String)">send</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.IllegalArgumentException</code></dd>
<dd><code>java.nio.channels.NotYetConnectedException</code></dd>
<dd><code><a href="../../org/java_websocket/exceptions/WebsocketNotConnectedException.html" title="class in org.java_websocket.exceptions">WebsocketNotConnectedException</a></code></dd></dl>
</li>
</ul>
<a name="send(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>send</h4>
<pre>public&nbsp;void&nbsp;send(java.nio.ByteBuffer&nbsp;bytes)
          throws java.lang.IllegalArgumentException,
                 <a href="../../org/java_websocket/exceptions/WebsocketNotConnectedException.html" title="class in org.java_websocket.exceptions">WebsocketNotConnectedException</a></pre>
<div class="block">Send Binary data (plain bytes) to the other end.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#send(java.nio.ByteBuffer)">send</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.IllegalArgumentException</code></dd>
<dd><code>java.nio.channels.NotYetConnectedException</code></dd>
<dd><code><a href="../../org/java_websocket/exceptions/WebsocketNotConnectedException.html" title="class in org.java_websocket.exceptions">WebsocketNotConnectedException</a></code></dd></dl>
</li>
</ul>
<a name="send(byte[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>send</h4>
<pre>public&nbsp;void&nbsp;send(byte[]&nbsp;bytes)
          throws java.lang.IllegalArgumentException,
                 <a href="../../org/java_websocket/exceptions/WebsocketNotConnectedException.html" title="class in org.java_websocket.exceptions">WebsocketNotConnectedException</a></pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#send(byte[])">send</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.IllegalArgumentException</code></dd>
<dd><code><a href="../../org/java_websocket/exceptions/WebsocketNotConnectedException.html" title="class in org.java_websocket.exceptions">WebsocketNotConnectedException</a></code></dd></dl>
</li>
</ul>
<a name="send(java.util.Collection)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>send</h4>
<pre>private&nbsp;void&nbsp;send(java.util.Collection&lt;<a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&gt;&nbsp;frames)</pre>
</li>
</ul>
<a name="sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode, java.nio.ByteBuffer, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sendFragmentedFrame</h4>
<pre>public&nbsp;void&nbsp;sendFragmentedFrame(<a href="../../org/java_websocket/framing/Framedata.Opcode.html" title="enum in org.java_websocket.framing">Framedata.Opcode</a>&nbsp;op,
                       java.nio.ByteBuffer&nbsp;buffer,
                       boolean&nbsp;fin)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode,%20java.nio.ByteBuffer,%20boolean)">WebSocket</a></code></strong></div>
<div class="block">Allows to send continuous/fragmented frames conveniently. <br>
 For more into on this frame type see http://tools.ietf.org/html/rfc6455#section-5.4<br>
 
 If the first frame you send is also the last then it is not a fragmented frame and will received via onMessage instead of onFragmented even though it was send by this method.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode,%20java.nio.ByteBuffer,%20boolean)">sendFragmentedFrame</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>op</code> - This is only important for the first frame in the sequence. Opcode.TEXT, Opcode.BINARY are allowed.</dd><dd><code>buffer</code> - The buffer which contains the payload. It may have no bytes remaining.</dd><dd><code>fin</code> - true means the current frame is the last in the sequence.</dd></dl>
</li>
</ul>
<a name="sendFrame(org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sendFrame</h4>
<pre>public&nbsp;void&nbsp;sendFrame(<a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;framedata)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#sendFrame(org.java_websocket.framing.Framedata)">sendFrame</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="hasBufferedData()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasBufferedData</h4>
<pre>public&nbsp;boolean&nbsp;hasBufferedData()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#hasBufferedData()">hasBufferedData</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isFlashEdgeCase(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isFlashEdgeCase</h4>
<pre>private&nbsp;<a href="../../org/java_websocket/drafts/Draft.HandshakeState.html" title="enum in org.java_websocket.drafts">Draft.HandshakeState</a>&nbsp;isFlashEdgeCase(java.nio.ByteBuffer&nbsp;request)
                                      throws <a href="../../org/java_websocket/exceptions/IncompleteHandshakeException.html" title="class in org.java_websocket.exceptions">IncompleteHandshakeException</a></pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../org/java_websocket/exceptions/IncompleteHandshakeException.html" title="class in org.java_websocket.exceptions">IncompleteHandshakeException</a></code></dd></dl>
</li>
</ul>
<a name="startHandshake(org.java_websocket.handshake.ClientHandshakeBuilder)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>startHandshake</h4>
<pre>public&nbsp;void&nbsp;startHandshake(<a href="../../org/java_websocket/handshake/ClientHandshakeBuilder.html" title="interface in org.java_websocket.handshake">ClientHandshakeBuilder</a>&nbsp;handshakedata)
                    throws <a href="../../org/java_websocket/exceptions/InvalidHandshakeException.html" title="class in org.java_websocket.exceptions">InvalidHandshakeException</a></pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../org/java_websocket/exceptions/InvalidHandshakeException.html" title="class in org.java_websocket.exceptions">InvalidHandshakeException</a></code></dd></dl>
</li>
</ul>
<a name="write(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>private&nbsp;void&nbsp;write(java.nio.ByteBuffer&nbsp;buf)</pre>
</li>
</ul>
<a name="write(java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>private&nbsp;void&nbsp;write(java.util.List&lt;java.nio.ByteBuffer&gt;&nbsp;bufs)</pre>
</li>
</ul>
<a name="open(org.java_websocket.handshake.Handshakedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>open</h4>
<pre>private&nbsp;void&nbsp;open(<a href="../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;d)</pre>
</li>
</ul>
<a name="isConnecting()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isConnecting</h4>
<pre>public&nbsp;boolean&nbsp;isConnecting()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#isConnecting()">isConnecting</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isOpen()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isOpen</h4>
<pre>public&nbsp;boolean&nbsp;isOpen()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#isOpen()">isOpen</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isClosing()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isClosing</h4>
<pre>public&nbsp;boolean&nbsp;isClosing()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#isClosing()">isClosing</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isFlushAndClose()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isFlushAndClose</h4>
<pre>public&nbsp;boolean&nbsp;isFlushAndClose()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#isFlushAndClose()">WebSocket</a></code></strong></div>
<div class="block">Returns true when no further frames may be submitted<br>
 This happens before the socket connection is closed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#isFlushAndClose()">isFlushAndClose</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isClosed()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isClosed</h4>
<pre>public&nbsp;boolean&nbsp;isClosed()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#isClosed()">WebSocket</a></code></strong></div>
<div class="block">Returns whether the close handshake has been completed and the socket is closed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#isClosed()">isClosed</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="getReadyState()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getReadyState</h4>
<pre>public&nbsp;<a href="../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a>&nbsp;getReadyState()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#getReadyState()">WebSocket</a></code></strong></div>
<div class="block">Retrieve the WebSocket 'readyState'.
 This represents the state of the connection.
 It returns a numerical value, as per W3C WebSockets specs.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#getReadyState()">getReadyState</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Returns:</span></dt><dd>Returns '0 = CONNECTING', '1 = OPEN', '2 = CLOSING' or '3 = CLOSED'</dd></dl>
</li>
</ul>
<a name="hashCode()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hashCode</h4>
<pre>public&nbsp;int&nbsp;hashCode()</pre>
<dl>
<dt><strong>Overrides:</strong></dt>
<dd><code>hashCode</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
</dl>
</li>
</ul>
<a name="toString()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>toString</h4>
<pre>public&nbsp;java.lang.String&nbsp;toString()</pre>
<dl>
<dt><strong>Overrides:</strong></dt>
<dd><code>toString</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
</dl>
</li>
</ul>
<a name="getRemoteSocketAddress()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRemoteSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getRemoteSocketAddress()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#getRemoteSocketAddress()">getRemoteSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="getLocalSocketAddress()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLocalSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getLocalSocketAddress()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#getLocalSocketAddress()">getLocalSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="getDraft()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDraft</h4>
<pre>public&nbsp;<a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;getDraft()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#getDraft()">getDraft</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="close()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#close()">WebSocket</a></code></strong></div>
<div class="block">Convenience function which behaves like close(CloseFrame.NORMAL)</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#close()">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="getResourceDescriptor()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getResourceDescriptor</h4>
<pre>public&nbsp;java.lang.String&nbsp;getResourceDescriptor()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WebSocket.html#getResourceDescriptor()">WebSocket</a></code></strong></div>
<div class="block">Returns the HTTP Request-URI as defined by http://tools.ietf.org/html/rfc2616#section-5.1.2<br>
 If the opening handshake has not yet happened it will return null.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WebSocket.html#getResourceDescriptor()">getResourceDescriptor</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketImpl.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../org/java_websocket/WebSocketFactory.html" title="interface in org.java_websocket"><span class="strong">Prev Class</span></a></li>
<li><a href="../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?org/java_websocket/WebSocketImpl.html" target="_top">Frames</a></li>
<li><a href="WebSocketImpl.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
